---
apiVersion: helm.toolkit.fluxcd.io/v2
kind: HelmRelease
metadata:
  name: backend
  namespace: transmittal

spec:
  interval: 10m

  chart:
    spec:
      chart: universal-chart
      version: "0.1.9"
      sourceRef:
        kind: HelmRepository
        name: yc-oci-charts
        namespace: flux-system
      interval: 10m

  install:
    remediation:
      retries: 3

  upgrade:
    remediation:
      retries: 3

  values:
    global:
      env: _default

    services:
      backend:
        enabled: true

        serviceAccount:
          enabled:
            _default: true
          name:
            _default: transmittal-vault

        image:
          name:
            _default: cr.yandex/crp3ccidau046kdj8g9q/transmittal-api:prod_a9d879ae
          pullPolicy:
            _default: IfNotPresent

        deployment:
          enabled: true

          name:
            _default: backend

          replicaCount:
            _default: 1

          port:
            _default: 8000

          command:
            _default: ["/bin/bash", "-ec"]
          args:
            _default:
              - |
                set -a
                [ -f /vault/secrets/transmittal-db ] && . /vault/secrets/transmittal-db
                [ -f /vault/secrets/transmittal-rabbitmq ] && . /vault/secrets/transmittal-rabbitmq
                [ -f /vault/secrets/transmittal-s3 ] && . /vault/secrets/transmittal-s3
                [ -f /vault/secrets/transmittal-django-auth ] && . /vault/secrets/transmittal-django-auth
                [ -f /vault/secrets/transmittal-public-key ] && . /vault/secrets/transmittal-public-key
                [ -f /vault/secrets/transmittal-mailgun ] && . /vault/secrets/transmittal-mailgun
                set +a
                exec scripts/entrypoint.sh

          resources:
            requests:
              cpu:
                _default: 25m
              memory:
                _default: 128Mi

          probes:
            liveness:
              enabled: false
            readiness:
              enabled: false

        service:
          enabled: true

          name:
            _default: backend-svc

          type:
            _default: ClusterIP

          port:
            _default: 80

          targetPort:
            _default: 8000

          portName:
            _default: http

        imagePullSecrets:
          enabled:
            _default: true
          name:
            _default: regcred

        envs:
          - name: TRANSMITTAL_SERVICE_APP__NAME
            value:
              _default: "Transmittal Service"

          - name: TRANSMITTAL_SERVICE_APP__LOG_LEVEL
            value:
              _default: "ERROR"

          - name: TRANSMITTAL_SERVICE_FLOWS_REPOSITORY__BASE_URL
            value:
              _default: "http://backend-svc.flows.svc.cluster.local:80"

          - name: TRANSMITTAL_SERVICE_FLOWS_REPOSITORY__MAX_CONNECTIONS
            value:
              _default: "10"

          - name: TRANSMITTAL_SERVICE_FLOWS_REPOSITORY__MAX_KEEPALIVE_CONNECTIONS
            value:
              _default: "5"

          - name: TRANSMITTAL_SERVICE_FLOWS_REPOSITORY__TIMEOUT
            value:
              _default: "30"

          - name: TRANSMITTAL_SERVICE_APP__HOST
            value:
              _default: "https://sarex.contour.infra.sarex.tech/transmittal"

          - name: TRANSMITTAL_SERVICE_APP__ENVIRONMENT
            value:
              _default: "prod"

          - name: TRANSMITTAL_SERVICE_CORS__ALLOW_ORIGINS
            value:
              _default: '["*"]'

          - name: TRANSMITTAL_SERVICE_CORS__ALLOW_METHODS
            value:
              _default: '["*"]'

          - name: TRANSMITTAL_SERVICE_CORS__ALLOW_HEADERS
            value:
              _default: '["*"]'

          - name: TRANSMITTAL_SERVICE_CORS__ALLOW_CREDENTIALS
            value:
              _default: "true"

          - name: TRANSMITTAL_SERVICE_UVICORN__HOST
            value:
              _default: "0.0.0.0"

          - name: TRANSMITTAL_SERVICE_UVICORN__PORT
            value:
              _default: "8000"

          - name: TRANSMITTAL_SERVICE_UVICORN__ENABLE_AUTO_RELOAD
            value:
              _default: "false"

          - name: TRANSMITTAL_SERVICE_OTEL__ENABLE
            value:
              _default: "false"

          - name: TRANSMITTAL_SERVICE_OTEL__HOST
            value:
              _default: "http://signoz-otel-collector-external.signoz.svc.cluster.local:4317"

          - name: TRANSMITTAL_SERVICE_OTEL__SERVICE_NAME
            value:
              _default: "backend.transmittals-prod"

          - name: TRANSMITTAL_SERVICE_OTEL__INSECURE
            value:
              _default: "false"

          - name: TRANSMITTAL_SERVICE_DATABASE__SSL_MODE
            value:
              _default: "verify-full"

          - name: TRANSMITTAL_SERVICE_DATABASE__SSL_ROOT_CERT_PATH
            value:
              _default: "/opt/.postgresql/root.crt"

          - name: TRANSMITTAL_SERVICE_UVICORN__LOG_LEVEL
            value:
              _default: "info"

          - name: TRANSMITTAL_SERVICE_UVICORN__NUM_WORKERS
            value:
              _default: "2"

          - name: TRANSMITTAL_SERVICE_UVICORN__ROOT_PATH
            value:
              _default: ""

          - name: TRANSMITTAL_SERVICE_DATABASE__ENABLE_SSL
            value:
              _default: "false"

          - name: TRANSMITTAL_SERVICE_RABBITMQ__HOST
            value:
              _default: "rabbitmq.rabbitmq.svc.cluster.local"

          - name: TRANSMITTAL_SERVICE_RABBITMQ__PORT
            value:
              _default: "5672"

          - name: TRANSMITTAL_SERVICE_SAREX_BACKEND_REPOSITORY__BASE_URL
            value:
              _default: "http://backend-svc.django.svc.cluster.local:80"

          - name: TRANSMITTAL_SERVICE_SAREX_BACKEND_REPOSITORY__MAX_CONNECTIONS
            value:
              _default: "10"

          - name: TRANSMITTAL_SERVICE_SAREX_BACKEND_REPOSITORY__MAX_KEEPALIVE_CONNECTIONS
            value:
              _default: "5"

          - name: TRANSMITTAL_SERVICE_SAREX_BACKEND_REPOSITORY__TIMEOUT
            value:
              _default: "15"

          - name: TRANSMITTAL_SERVICE_RESOURCE_REPOSITORY__BASE_URL
            value:
              _default: "http://iam-backend.iam.svc.cluster.local:8000"

          - name: TRANSMITTAL_SERVICE_RESOURCE_REPOSITORY__MAX_CONNECTIONS
            value:
              _default: "10"

          - name: TRANSMITTAL_SERVICE_RESOURCE_REPOSITORY__MAX_KEEPALIVE_CONNECTIONS
            value:
              _default: "5"

          - name: TRANSMITTAL_SERVICE_RESOURCE_REPOSITORY__TIMEOUT
            value:
              _default: "15"

          - name: TRANSMITTAL_SERVICE_DOCUMENTATIONS_REPOSITORY__BASE_URL
            value:
              _default: "http://documentations-api.documentations.svc.cluster.local:8080"

          - name: TRANSMITTAL_SERVICE_DOCUMENTATIONS_REPOSITORY__MAX_CONNECTIONS
            value:
              _default: "10"

          - name: TRANSMITTAL_SERVICE_DOCUMENTATIONS_REPOSITORY__MAX_KEEPALIVE_CONNECTIONS
            value:
              _default: "5"

          - name: TRANSMITTAL_SERVICE_DOCUMENTATIONS_REPOSITORY__TIMEOUT
            value:
              _default: "15"

          - name: TRANSMITTAL_SERVICE_S3_CLIENT__MAX_POOL_CONNECTIONS
            value:
              _default: "10"

          - name: TRANSMITTAL_SERVICE_S3_CLIENT__CONNECT_TIMEOUT
            value:
              _default: "10"

          - name: TRANSMITTAL_SERVICE_S3_CLIENT__READ_TIMEOUT
            value:
              _default: "50"

          - name: TRANSMITTAL_SERVICE_S3_CLIENT__REGION_NAME
            value:
              _default: "ru-central1"

          - name: TRANSMITTAL_SERVICE_S3_CLIENT__VERIFY
            value:
              _default: "true"

          - name: TRANSMITTAL_SERVICE_S3_CLIENT__ENDPOINT
            value:
              _default: "minio.minio.svc.cluster.local:9000"

          - name: TRANSMITTAL_SERVICE_S3_CLIENT__USE_SSL
            value:
              _default: "false"

          - name: TRANSMITTAL_SERVICE_HTML_TO_PDF_CONVERTER__BASE_URL
            value:
              _default: "http://export-project-service.django.svc.cluster.local:8000"

          - name: TRANSMITTAL_SERVICE_HTML_TO_PDF_CONVERTER__MAX_CONNECTIONS
            value:
              _default: "10"

          - name: TRANSMITTAL_SERVICE_HTML_TO_PDF_CONVERTER__MAX_KEEPALIVE_CONNECTIONS
            value:
              _default: "5"

          - name: TRANSMITTAL_SERVICE_HTML_TO_PDF_CONVERTER__TIMEOUT
            value:
              _default: "50"

          - name: TRANSMITTAL_SERVICE_MARKINGS__BASE_URL
            value:
              _default: "http://marks-service.documentations.svc.cluster.local:8000"

          - name: TRANSMITTAL_SERVICE_MARKINGS__MAX_CONNECTIONS
            value:
              _default: "10"

          - name: TRANSMITTAL_SERVICE_MARKINGS__MAX_KEEPALIVE_CONNECTIONS
            value:
              _default: "5"

          - name: TRANSMITTAL_SERVICE_MARKINGS__TIMEOUT
            value:
              _default: "50"

          - name: TRANSMITTAL_SERVICE_MAILGUN__BASE_URL
            value:
              _default: "https://api.mailgun.net/v3/mg.sarex.io"

          - name: TRANSMITTAL_SERVICE_MAILGUN__MAX_CONNECTIONS
            value:
              _default: "10"

          - name: TRANSMITTAL_SERVICE_MAILGUN__MAX_KEEPALIVE_CONNECTIONS
            value:
              _default: "5"

          - name: TRANSMITTAL_SERVICE_MAILGUN__TIMEOUT
            value:
              _default: "15"

          - name: TRANSMITTAL_SERVICE_MAILGUN__EMAIL
            value:
              _default: "hello@wb.io"

        podAnnotations:
          _default:
            traffic.sidecar.istio.io/excludeOutboundPorts: "8200"
            vault.hashicorp.com/agent-init-first: "true"
            vault.hashicorp.com/agent-inject: "true"
            vault.hashicorp.com/agent-pre-populate-only: "true"
            vault.hashicorp.com/auth-path: auth/kubernetes
            vault.hashicorp.com/role: transmittal
            vault.hashicorp.com/agent-inject-secret-transmittal-db: secrets/data/apps/transmittal/postgres
            vault.hashicorp.com/agent-inject-template-transmittal-db: |-
              {{- with secret "secrets/data/apps/transmittal/postgres" -}}
              TRANSMITTAL_SERVICE_DATABASE__USER={{ index .Data.data "username" }}
              TRANSMITTAL_SERVICE_DATABASE__PASSWORD={{ index .Data.data "password" }}
              TRANSMITTAL_SERVICE_DATABASE__HOST={{ index .Data.data "host" }}
              TRANSMITTAL_SERVICE_DATABASE__PORT={{ index .Data.data "port" }}
              TRANSMITTAL_SERVICE_DATABASE__NAME={{ index .Data.data "database" }}
              {{- end -}}
            vault.hashicorp.com/agent-inject-secret-transmittal-rabbitmq: secrets/data/rabbitmq/apps/transmittal
            vault.hashicorp.com/agent-inject-template-transmittal-rabbitmq: |-
              {{- with secret "secrets/data/rabbitmq/apps/transmittal" -}}
              TRANSMITTAL_SERVICE_RABBITMQ__USER={{ index .Data.data "username" }}
              TRANSMITTAL_SERVICE_RABBITMQ__PASSWORD={{ index .Data.data "password" }}
              TRANSMITTAL_SERVICE_RABBITMQ__VHOST={{ index .Data.data "vhost" }}
              {{- end -}}
            vault.hashicorp.com/agent-inject-secret-transmittal-s3: secrets/data/minio/apps/transmittal
            vault.hashicorp.com/agent-inject-template-transmittal-s3: |-
              {{- with secret "secrets/data/minio/apps/transmittal" -}}
              TRANSMITTAL_SERVICE_S3_CLIENT__ACCESS_KEY={{ index .Data.data "access_key" }}
              TRANSMITTAL_SERVICE_S3_CLIENT__SECRET_KEY={{ index .Data.data "secret_key" }}
              {{- $buckets := index .Data.data "buckets" }}
              TRANSMITTAL_SERVICE_S3_CLIENT__DEFAULT_BUCKET={{- if gt (len $buckets) 0 -}}{{ index (index $buckets 0) "name" }}{{- else -}}transmittal-storage{{- end -}}
              {{- end -}}
            vault.hashicorp.com/agent-inject-secret-transmittal-django-auth: secrets/data/vault/common/django_auth
            vault.hashicorp.com/agent-inject-template-transmittal-django-auth: |-
              {{- with secret "secrets/data/vault/common/django_auth" -}}
              TRANSMITTAL_SERVICE_SAREX_BACKEND_REPOSITORY__BASIC_AUTH_ENCODED={{ index .Data.data "key" }}
              {{- end -}}
            vault.hashicorp.com/agent-inject-secret-transmittal-public-key: secrets/data/vault/common/rsa_keys
            vault.hashicorp.com/agent-inject-template-transmittal-public-key: |-
              {{- with secret "secrets/data/vault/common/rsa_keys" -}}
              TRANSMITTAL_SERVICE_AUTH__PUBLIC_KEY={{ printf "%q" (index .Data.data "public_key") }}
              {{- end -}}
            vault.hashicorp.com/agent-inject-secret-transmittal-mailgun: secrets/data/vault/apps/transmittal
            vault.hashicorp.com/agent-inject-template-transmittal-mailgun: |-
              {{- with secret "secrets/data/vault/apps/transmittal" -}}
              TRANSMITTAL_SERVICE_MAILGUN__API_KEY={{ index .Data.data "TRANSMITTAL_SERVICE_MAILGUN__API_KEY" }}
              {{- end -}}

        commitSha: ""
        gitlabUri: ""
        gitlabJobUrl: ""
        owner: ""
